//+------------------------------------------------------------------+
//|                                                Complex_class.mqh |
//|                                                           denkir |
//|                                                 denkir@gmail.com |
//+------------------------------------------------------------------+
#property copyright "denkir"
#property link      "denkir@gmail.com"
//+------------------------------------------------------------------+
//|          Complex Class definition                                |
//+------------------------------------------------------------------+
class Complex
  {
public:
   double            re,im; //re -   , im - 
public:
   void              Complex(){};                                   //   
   void              setComplex(double rE,double iM){re=rE; im=iM;};//set- (1- )
   void              setComplex(double rE){re=rE; im=0;};           //set- (2- )
   void              ~Complex(){};                                  //
   void              opEqual(const Complex &y){re=y.re;im=y.im;};   //operator=
   void              opPlus(const Complex &x,const Complex &y);     //operator+   
   void              opPlusEq(const Complex &y);                    //operator+=
   void              opMinus(const Complex &x,const Complex &y);    //operator- 
   void              opMult(const Complex &x,const Complex &y);     //operator*   
   void              opMultEq(const Complex &y);                    //operator*= (1- )     
   void              opMultEq(const double y);                      //operator*= (2- )    
   void              conjugate(const Complex &y);                   //  
   double            norm();                                        //
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void setComplexArr(Complex &cArr[],double &rE[])
//        
  {
   int n=ArraySize(rE);
   for(int i=0;i<n;i++)
     {
      cArr[i].re=rE[i]; cArr[i].im=0;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void setComplexArr2(Complex &cArr[],double &rA[][2])
//        
  {
   int n=ArraySize(rA)/2;
   for(int i=0;i<n;i++)
     {
      cArr[i].re=rA[i][0];
      cArr[i].im=rA[i][1];;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void getComplexArr(double &rE[][2],Complex &cArr[])
//       
  {
   int n=ArraySize(cArr);
   for(int i=0;i<n;i++)
     {
      rE[i][0]=cArr[i].re;
      rE[i][1]=cArr[i].im;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Complex::opMinus(const Complex &x,const Complex &y) //operator-
  {
   re=x.re-y.re; 
   im= x.im - y.im;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Complex::opMult(const Complex &x,const Complex &y) //operator*
  {
   re=x.re*y.re-x.im*y.im; //
   im= x.re*y.im + x.im*y.re;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Complex::opMultEq(const Complex &y) //operator*= (1- )  
  {
   const double temp=re;
   re = re * y.re - im * y.im;
   im = im * y.re + temp*y.im;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Complex::opMultEq(const double y)  //operator* (2- )  
  {
   re*=y;
   im*=y;
  }
//+------------------------------------------------------------------+
double Complex::norm() //
  {
   return re*re+im*im;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Complex::opPlus(const Complex &x,const Complex &y) //operator+
  {
   re = x.re + y.re;
   im = x.im + y.im;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Complex::opPlusEq(const Complex &y) //operator+=
  {
   re += y.re;
   im += y.im;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Complex::conjugate(const Complex &y) //  
  {
   re = y.re;
   im = (-1)*y.im;
  }
//+------------------------------------------------------------------+